﻿Public Class Form1

    Dim labels As New Dictionary(Of Integer, Label)
    Dim gameStarted As Boolean = False
    Dim previousClick As Integer = 0

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Button2.Visible = True
        Me.AcceptButton = Button2
        gameStarted = False
        If NumericUpDown1.Value <> 0 Then
            Timer1.Interval = NumericUpDown1.Value
            Timer1.Enabled = True
        End If

        'generate random numbers
        For i = 1 To NumericUpDown2.Value
            Dim index As Integer = Math.Round(Rnd() * 39)
            While labels(index).Text <> "0"
                index = Math.Round(Rnd() * NumericUpDown2.Value)
            End While
            labels(index).Text = i.ToString
        Next i
        Button1.Visible = False
        colorBoxes()
    End Sub

    Private Sub colorBoxes()
        For i = 0 To 39
            If labels(i).Tag = "a" Then                  'box has not been clicked
                If labels(i).Text = "0" Then             'nothing is assigned to this box
                    If CheckBox1.Checked Then            'should draw white boxes
                        labels(i).BackColor = Color.White
                        labels(i).ForeColor = Color.White
                    Else                                 'should not draw white boxes
                        labels(i).BackColor = Color.Black
                        labels(i).ForeColor = Color.Black
                    End If
                Else                                      'something is assigned to this box
                    If gameStarted = True Then            'user has already clicked the first box
                        If CheckBox2.Checked Then         'should draw white boxes after first click
                            labels(i).BackColor = Color.White
                            labels(i).ForeColor = Color.White
                        Else                              'should not draw white boxes after first click
                            labels(i).BackColor = Color.Black
                            labels(i).ForeColor = Color.White
                        End If
                    Else                                  'user has not clicked anything yet
                        labels(i).BackColor = Color.Black
                        labels(i).ForeColor = Color.White
                    End If
                End If
            Else                                          'box has been clicked
                labels(i).ForeColor = Color.Black
                labels(i).BackColor = Color.Black
            End If
            'labels(i).ForeColor = Color.White
        Next i
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Randomize()
        Dim margin As Integer = 60
        For i As Integer = 0 To 39
            Dim L As New Label
            L.BackColor = Color.Black
            L.ForeColor = Color.Black
            L.TextAlign = ContentAlignment.MiddleCenter
            L.Font = New Font("Microsoft Sans Serif", 20)
            L.Height = 50
            L.Width = 50
            L.Left = (i Mod 8) * margin + 219
            L.Top = (i \ 8) * margin + 10
            L.Text = "0"
            L.Tag = "a"
            Me.Controls.Add(L)
            labels.Add(i, L)
            AddHandler L.Click, AddressOf Label_Click
        Next i
    End Sub

    Private Sub Label_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        sender.tag = "b"
        gameStarted = True
        If previousClick = Val(sender.text) - 1 Then 'success
            previousClick = Val(sender.text)
            If previousClick = NumericUpDown2.Value Then 'game win
                For i = 0 To 39
                    labels(i).BackColor = Color.Green
                    labels(i).ForeColor = Color.Green
                Next i
                Me.BackColor = Color.Green
                Exit Sub
            End If
        Else                                   'incorrect click, game loss
            For i = 0 To 39
                labels(i).BackColor = Color.Red
                labels(i).ForeColor = Color.Red
            Next i
            Me.BackColor = Color.Red
            Exit Sub
        End If
        colorBoxes()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        previousClick = 0
        For i = 0 To 39
            labels(i).BackColor = Color.Black
            labels(i).ForeColor = Color.Black
            labels(i).Text = "0"
            labels(i).Tag = "a"
        Next i
        Button1.Visible = True
        Button2.Visible = False
        Me.AcceptButton = Button1
        Me.BackColor = Color.Black
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        gameStarted = True
        Timer1.Enabled = False
        colorBoxes()
    End Sub
End Class
